package mwsystem;

import java.io.*;

public class MesswertAppl
{
	private DataRecorder drec = null;
	private PubDataRecorder pdr = null;
	private DataProvider sensor = null;
	private AverageObserver avobsrv = null;
	private MaxLimitObserver mlobsrv = null;

	public MesswertAppl(int memsize, int blksize, float limit, float min, float max)
	{
		drec = new DataRecorder(memsize);
		pdr = new PubDataRecorder(drec);
		sensor = new DataProvider(min, max);
		mlobsrv = new MaxLimitObserver(pdr, limit);
		avobsrv = new AverageObserver(pdr, blksize);
		pdr.attach(mlobsrv);
		pdr.attach(avobsrv);
	}
	//Hierbei kommt es faelschlicherweise zu einer doppelten Ausgabe nach Betaetigung der
	//ENTER Taste unter Windows. Dies liegt an einer unterschiedlichen Interpretierung der ENTER Taste
	//bei UNIX Gearten und Windows Geraeten
	public void messen() throws IOException
	{
		float val;
		System.out.println("Start Messung !");
		
		while (System.in.read() != -1) // RET-Taste CTRL-Z liefert -1
		{
			val = sensor.data();
			System.out.println(val);
			pdr.record(val);
		}
	}

	public static void main(String[] args) throws IOException
	{
		MesswertAppl mwa = new MesswertAppl(20, 6, 15.0f, 2.0f, 20.0f);
		mwa.messen();
	}
}
